<template>
  <q-dialog
    v-model="isOpen"
    persistent
    transition-show="scale"
    transition-hide="scale"
  >
    <q-card class="full-width" style="max-width: 450px">
      <q-linear-progress indeterminate v-show="loading" />
      <q-card-section class="q-pa-md">
        <div class="col-xs-12 text-h6 text-grey-10">
          {{ title || 'Dialog' }}
        </div>
      </q-card-section>
      <q-separator />
      <q-card-section class="q-pa-md">
        <app-form :on-submit="handleFormSubmit">
          <div class="row full-width q-px-lg">
            <slot></slot>
          </div>
          <div class="row justify-between q-py-md q-px-md">
            <div class="col-xs-4">
              <q-btn
                class="full-width"
                @click="onCancel"
                unelevated
                outline
                :disable="loading"
              >
                {{ t('cancelButton') }}
              </q-btn>
            </div>
            <div class="col-xs-4">
              <q-btn
                unelevated
                class="full-width"
                type="submit"
                :disable="loading"
                :loading="loading"
                color="primary"
              >
                {{ t('submit') }}
              </q-btn>
            </div>
          </div>
        </app-form>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script>
import AppForm from 'src/components/forms/AppForm';
import { useDialog } from 'src/hooks/dialogs-provider';
import { toRef } from 'vue';
import { useI18n } from 'vue-i18n';

export default {
  name: 'AppDialogForm',
  components: { AppForm },
  props: {
    name: {
      type: String,
      required: true,
    },
    onSubmit: Function,
    loading: {
      type: Boolean,
      required: false,
      default: false,
    },
    title: {
      type: String,
      required: false,
    },
  },
  setup(props) {
    const { close, isOpen } = useDialog(toRef(props, 'name'));

    const onCancel = () => {
      close();
    };

    const { t } = useI18n();

    const handleFormSubmit = (args) =>
      Promise.resolve()
        .then(() => props.onSubmit(args))
        .then(() => {
          console.log('dialog close');
          close();
        });

    return {
      isOpen,
      onCancel,
      handleFormSubmit,
      t,
    };
  },
};
</script>
